<template>
  <el-menu
    :default-active="activeMenu"
    mode="horizontal"
    @select="handleSelect"
  >
    <template v-for="(item, index) in topMenus">
      <el-menu-item
        :style="{ '--theme': theme }"
        :index="item.path"
        :key="index"
        v-if="index < visibleNumber"
      >
        <!-- <svg-icon :icon-class="item.meta.icon" /> -->
        {{ item.meta.title }}</el-menu-item
      >
    </template>

    <!-- 顶部菜单超出数量折叠 -->
    <el-submenu
      :style="{ '--theme': theme }"
      index="more"
      v-if="topMenus.length > visibleNumber"
    >
      <template slot="title">更多菜单</template>
      <template v-for="(item, index) in topMenus">
        <el-menu-item
          :index="item.path"
          :key="index"
          v-if="index >= visibleNumber"
        >
          <!-- <svg-icon :icon-class="item.meta.icon" /> -->
          {{ item.meta.title }}</el-menu-item
        >
      </template>
    </el-submenu>
  </el-menu>
</template>

<script>
import store from "@/store";
import { constantRoutes } from "@/router";

// 隐藏侧边栏路由
const hideList = ["/index", "/user/profile"];

export default {
  data() {
    return {
      // 顶部栏初始数
      visibleNumber: 5,
      // 当前激活菜单的 index
      currentIndex: undefined,
      topMenus: [],
      constantRoute: []
    };
  },
  computed: {
    theme() {
      return this.$store.state.settings.theme;
    },
    // 默认激活的菜单
    activeMenu() {
      const path = this.$route.path;
      let activePath = path;
      if (
        path !== undefined &&
        path.lastIndexOf("/") > 0 &&
        hideList.indexOf(path) === -1
      ) {
        const tmpPath = path.substring(1, path.length);
        activePath = "/" + tmpPath.substring(0, tmpPath.indexOf("/"));
        this.$store.dispatch("app/toggleSideBarHide", false);
      } else if (!this.$route.children) {
        activePath = path;
        this.$store.dispatch("app/toggleSideBarHide", true);
      }
      this.activeRoutes(activePath);
      return activePath;
    }
  },
  beforeMount() {
    window.addEventListener("resize", this.setVisibleNumber);
  },
  beforeDestroy() {
    window.removeEventListener("resize", this.setVisibleNumber);
  },
  mounted() {
    this.setRouters();
    this.setVisibleNumber();
  },
  methods: {
    // 设置子路由
    childrenMenus(routers) {
      var childrenMenus = [];
      routers.map((router) => {
        for (var item in router.children) {
          if (router.children[item].parentPath === undefined) {
            if (router.path === "/") {
              router.children[item].path = "/" + router.children[item].path;
            } else {
              if (!this.ishttp(router.children[item].path)) {
                router.children[item].path =
                  router.path + "/" + router.children[item].path;
              }
            }
            router.children[item].parentPath = router.path;
          }
          childrenMenus.push(router.children[item]);
        }
      });
      this.constantRoute = constantRoutes.concat(childrenMenus);
    },

    // 顶部显示菜单
    topMenuss(routers) {
      this.topMenus = [];
      routers.map((menu) => {
        if (menu.hidden !== true) {
          // 兼容顶部栏一级菜单内部跳转
          if (menu.path === "/") {
            this.topMenus.push(menu.children[0]);
          } else {
            this.topMenus.push(menu);
          }
        }
      });
    },

    // 所有的路由信息
    async setRouters() {
      const { roles } = await store.dispatch("user/getInfo");
      // generate accessible routes map based on roles
      const accessRoutes = await store.dispatch(
        "permission/generateRoutes",
        roles
      );

      accessRoutes.unshift({
        children: [
          {
            id: "dashboard",
            hidden: false,
            meta: {
              title: "首页",
              icon: 'dashboard'
            },
            parentPath: "/homePage",
            name: "Dashboard",
            path: "/homePage/dashboard",
            component: "/dashboard/index"
          }
        ],
        alwaysShow: true,
        id: "homePage",
        path: "/homePage",
        meta: {
          title: "首页"
        },
        redirect: "/homePage/dashboard"
      });
      this.topMenuss(accessRoutes);
      this.childrenMenus(accessRoutes);
      // return accessRoutes;
    },

    // 根据宽度计算设置显示栏数
    setVisibleNumber() {
      const width = document.body.getBoundingClientRect().width / 3;
      this.visibleNumber = parseInt(width / 85);
    },

    // 菜单选择事件
    handleSelect(key, keyPath) {
      this.currentIndex = key;
      const route = this.topMenus.find((item) => item.path === key);
      if (this.ishttp(key)) {
        // http(s):// 路径新窗口打开
        window.open(key, "_blank");
      } else if (!route || !route.children) {
        // 没有子路由路径内部打开
        this.$router.push({ path: key });
        this.$store.dispatch("app/toggleSideBarHide", true);
      } else {
        // 显示左侧联动菜单
        this.activeRoutes(key);
        this.$store.dispatch("app/toggleSideBarHide", false);
      }
      console.log(key);
      if (key === "/homePage") {
        this.$router.push({ path: "/homePage/dashboard" });
      }
    },

    // 当前激活的路由
    activeRoutes(key) {
      var routes = [];
      if (this.constantRoute && this.constantRoute.length > 0) {
        this.constantRoute.map((item) => {
          if (key == item.parentPath || (key == "index" && "" == item.path)) {
            routes.push(item);
          }
        });
      }
      if (routes.length > 0) {
        this.$store.commit("permission/SET_ROUTES", routes);
      }
    },

    ishttp(url) {
      return url.indexOf("http://") !== -1 || url.indexOf("https://") !== -1;
    }
  }
};
</script>

<style lang="scss" scope>
.topmenu-container.el-menu--horizontal > .el-menu-item {
  float: left;
  height: 50px !important;
  line-height: 50px !important;
  color: #1e1e1e !important;
  padding: 0 15px !important;
  margin: 0 10px !important;
  font-size: 16px;
  font-weight: 800;
  border-bottom: 0;
}

.topmenu-container.el-menu--horizontal > .el-menu-item.is-active,
.el-menu--horizontal > .el-submenu.is-active .el-submenu__title {
  border-bottom: 0;
  color: #{"var(--theme)"} !important;
  background: #f6f7fc;
}

/* submenu item */
.topmenu-container.el-menu--horizontal > .el-submenu .el-submenu__title {
  float: left;
  height: 50px !important;
  line-height: 50px !important;
  color: #999093 !important;
  margin: 0 10px !important;
  border-bottom: 0;
  font-size: 16px;
  font-weight: 800;
}
.topmenu-container.el-menu--horizontal
  > .el-submenu.is-active
  .el-submenu__title {
  border-bottom: 0;
  color: #{"var(--theme)"} !important;
  background: #f6f7fc;
}
#app .hideSidebar .el-submenu > .el-submenu__title {
  padding: 0 15px !important;
}
</style>
